/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_ERROR_H
#define GWF_ERROR_H

#ifdef __cplusplus
  extern "C" {
#endif

#include <gtk/gtk.h>

typedef enum _GwfErrType	GwfErrType;
enum _GwfErrType
{
  GWF_HINT,
  GWF_WARNING,
  GWF_ERROR
};

typedef void		(*GwfErrorFunc)		(gpointer user_data,GwfErrType type,gchar *message);

typedef struct _GwfError	GwfError;
struct _GwfError
{
  GHashTable	*errorlist;
  GwfErrorFunc	error;
  gpointer	func_data;
};

typedef struct _GwfErrData	GwfErrData;
struct _GwfErrData
{
  gchar		*name;
  GwfErrType	type;
  gchar		*message;
};

GwfError*	gwf_error_new		(void);
void		gwf_error_free		(GwfError *error);
void		gwf_error_set_func	(GwfError *error,GwfErrorFunc func,gpointer func_data);
gint		gwf_error_add_error	(GwfError *error,gchar *name,GwfErrType type,gchar *message);
void		gwf_error_remove_error	(GwfError *error,gchar *name);

void		gwf_error_raise_error	(GwfError *error,gchar *name,...);

#ifdef __cplusplus
  }
#endif

#endif
