/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_SOURCE_BASIC_H
#define GWF_SOURCE_BASIC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "gwf_project.h"
#include "gwf_error.h"
#include <gtk/gtk.h>

/* Prewriting check function */
gint	gwf_source_basic_check			(GwfProject *project,GwfError *error);

/* HFile write functions */
void	gwf_source_basic_write_includes_h	(GwfProject *project,GString *src);
void	gwf_source_basic_write_cast_defs	(GwfProject *project,GString *src);
void	gwf_source_basic_write_widget_tdef	(GwfProject *project,GString *src);
void	gwf_source_basic_write_widget		(GwfProject *project,GString *src);
void	gwf_source_basic_write_widget_class	(GwfProject *project,GString *src);
void	gwf_source_basic_write_func_decl_h	(GwfProject *project,GString *src);

/* CFile write functions */
void	gwf_source_basic_write_includes_c	(GwfProject *project,GString *src);
void	gwf_source_basic_write_func_decl_c	(GwfProject *project,GString *src);
void	gwf_source_basic_write_vars 		(GwfProject *project,GString *src);
void	gwf_source_basic_write_funcs		(GwfProject *project,GString *src);

#ifdef __cplusplus
}
#endif

#endif
