/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_SOURCE_TOOLS_H
#define GWF_SOURCE_TOOLS_H

#ifdef __cplusplus
  extern "C" {
#endif

#include <gtk/gtk.h>
#include "gwf_project.h"

gchar*		gwf_source_get_widname_as_func		(GwfProject *project);
gchar*		gwf_source_get_widname_as_struct	(GwfProject *project);
void		gwf_source_get_widname_as_def		(GwfProject *project,gchar **part1,gchar **part2);
gchar*		gwf_source_get_widname_as_var		(GwfProject *project);
gchar*		gwf_source_get_parent_as_func		(GwfProject *project);
gchar*		gwf_source_get_parent_as_struct		(GwfProject *project);
void		gwf_source_get_parent_as_def		(GwfProject *project,gchar **part1,gchar **part2);
gchar*		gwf_source_get_parent_as_var		(GwfProject *project);

void		gwf_source_add_tabs_before		(GString *src,gchar *text,gint maxlen);
void		gwf_source_add_tabs_after		(GString *src,gchar *text,gint maxlen);
void		gwf_source_add_tabs_before_printf	(GString *src,gint maxlen,gchar *format,...);
void		gwf_source_add_tabs_after_printf	(GString *src,gint maxlen,gchar *format,...);

void		gwf_source_add_tabs_before_until	(GString *src,gchar *text,gint until);
void		gwf_source_add_tabs_after_until		(GString *src,gchar *text,gint until);
void		gwf_source_add_tabs_before_until_printf	(GString *src,gint until,gchar *format,...);
void		gwf_source_add_tabs_after_until_printf	(GString *src,gint until,gchar *format,...);

gint		gwf_source_insert_tabs_before		(GString *src,gchar *text,gint pos,gint maxlen);
gint		gwf_source_insert_tabs_after		(GString *src,gchar *text,gint pos,gint maxlen);
gint		gwf_source_insert_tabs_before_printf	(GString *src,gint pos,gint maxlen,gchar *format,...);
gint		gwf_source_insert_tabs_after_printf	(GString *src,gint pos,gint maxlen,gchar *format,...);

gint		gwf_source_insert_tabs_before_until	(GString *src,gchar *text,gint pos,gint until);
gint 		gwf_source_insert_tabs_after_until	(GString *src,gchar *text,gint pos,gint until);
gint		gwf_source_insert_tabs_before_until_printf	(GString *src,gint pos,gint until,gchar *format,...);
gint		gwf_source_insert_tabs_after_until_printf	(GString *src,gint pos,gint until,gchar *format,...);

gint		gwf_source_insert			(GString *src,gint pos,gchar *text);
gint		gwf_source_insert_printf		(GString *src,gint pos,gchar *format,...);

gint		gwf_source_get_line_length		(gchar *line,gint pos);
gint		gwf_source_get_real_line_length		(gchar *line,gint pos);

gint		gwf_source_find_text			(GString *src,gchar *text);
gint		gwf_source_find_text_from_pos		(GString *src,gint pos,gchar *text);

#ifdef __cplusplus
  }
#endif

#endif
